10 REM------------------------------------------------
12 REM              F L A S H  1.6
15 REM  PRODUCED BY IEEE WORKING GROUP ON ESTIMATING
20 REM  LIGHTNING PERFORMANCE OF TRANSMISSION LINES
22 REM------------------------------------------------
23 REM BASED ON EPRI METHOD BY JOHN ANDERSON
24 REM ORIGINAL FORTRAN METHOD BY NATASHA ROUKOS
25 REM FIRST BASIC VERSION WRITTEN BY JIM WHITEHEAD 9/85
26 REM MODIFIED FOR IBM-PC BY BILL CHISHOLM 1/86 (416)231-4111 X6982
27 REM VERSION 1.4 BY JIM WHITEHEAD  9/87
28 REM VERSION 1.5 BY ROGER CLAYTON AND BILL CHISHOLM 1/89
29 REM VERSION 1.6 BY Ding Yuen and Bill Chisholm 1/90
37 REM---------------------
38 REM  GLOBAL FUNCTIONS 
39 REM---------------------
40 DEF FNA(TD)=.04*TD^1.25:REM                              GFD FROM TD
41 DEF FNB(TH)= ( (.054*TH^1.1)/.04 ) ^ (1/1.25): REM        TH FROM TD
42 DEF FNC(L)=L*820:REM               FLASHOVER VOLTAGE kV PER m AT 2 us
43 DEF FND(L)=L*585:REM               FLASHOVER VOLTAGE kV PER m AT 6 us
44 DEF FNS(IN)=8*IN^.65: REM      STRIKING DISTANCE (m) FROM CURRENT (kA)
45 DEF FNW(H)=4*H^1.09: REM            ATTRACTIVE WIDTH OF CONDUCTOR (m)
50 CLS
51 SCREEN 0,0,0
52 ON ERROR GOTO 60000
55 LOCATE 3,17: PRINT"***************************************************"
60 LOCATE 4,17: PRINT"*                 F L A S H  1.6                  *"
65 LOCATE 5,17: PRINT"*   PRODUCED BY IEEE WORKING GROUP ON ESTIMATING  *"
70 LOCATE 6,17: PRINT"* THE LIGHTNING PERFORMANCE OF TRANSMISSION LINES *"
75 LOCATE 7,17: PRINT"*                 JANUARY,  1990                  *"
80 LOCATE 8,17: PRINT"***************************************************"
98 REM ----FOR A COMPLETE LIST OF VARIABLES, SEE END OF PROGRAM LISTING
100 DIM A(13),CF(12),CX(12),CY(12),CZ(12,2),ET(12)
110 DIM F2(12),F6(12),GX(2),GY(2),IA(12),IC(12),IR(12),IS(12),IU(12)
120 DIM I2(12),I6(12),KE(13,20),KS(13,20),LV(12),MX(4),MY(4)
130 DIM PA(12),PH(12),PR(12),PX(12),SA(12),SI(12),SU(12),SV(36)
140 DIM TA(12),TH(12),VC(12),VI(12),VJ(12),VP(12),VR(12),VS(12)
150 DIM ACDC$(12),RF(10)
180 PI=3.14159:VL=300
200 LOCATE 18,5:PRINT"On Which Drive Will Your Data Be On?"
205 IOH=20:IOV=5:IOTTL$="Enter A, B, C, or D":IOSTR$="$$$A"
210 GOSUB 20000:DN$=IOSTR$
215 IF DN$="A" OR DN$="B" OR DN$="C" OR DN$="D" THEN 265
220 IF DN$="a" OR DN$="b" OR DN$="c" OR DN$="d" THEN 230
225 BEEP: GOTO 200
230 DN$=CHR$(ASC(DN$)-32)
250 REM------------
255 REM  MAIN MENU
260 REM------------
265 CLS: LB$=" M A I N  M E N U ":GOSUB 16000
270 LOCATE 5,5:PRINT"Do You Wish To:"
275 LOCATE 7,8:PRINT"1. Enter NEW DATA from KEYBOARD."
280 LOCATE 9,8:PRINT"2. Read OLD DATA from DISK DRIVE."
285 LOCATE 11,8:PRINT"3. Print SUMMARY of DATA"
290 LOCATE 13,8:PRINT"4. Modify EXISTING DATA."
295 LOCATE 15,8:PRINT"5. RUN PROGRAM with Current Data."
300 LOCATE 17,8:PRINT"6. QUIT."
305 IOH=20:IOV=8:IOVAL=1:IOTTL$="Enter 1, 2, 3, 4, 5 or 6 :":GOSUB 20000
310 IF IOVAL=1 THEN GOSUB 21000:GOTO 345: REM initialize to zeros
315 IF IOVAL=2 THEN GOSUB 12000:GOTO 14000: REM read in disk file
320 IF IOVAL=3 THEN 14040:REM print summary of data
325 IF IOVAL=4 THEN 345:REM edit existing data
330 IF IOVAL=5 THEN 1000: REM start program
335 IF IOVAL=6 THEN END
340 BEEP:GOTO 305
345 LB$=" D A T A   E N T R Y / E D I T  # 1":GOSUB 16000
350 REM------------------------------------------------
355 REM  BEGIN ENTRY/EDIT OF TRANSMISSION LINE DESCRIPTION
360 REM------------------------------------------------
365 IOTTL$="Do You Wish To Use (1) English or (2) Metric Units"
370 IOH=3:IOV=1:IOVAL=MM:GOSUB 20000: MM=IOVAL
375 IF MM<1 OR MM>2 THEN BEEP:GOTO 365
380 IOTTL$="What is the Line Name":IOH=5:IOV=1:IOSTR$="$$$"+TT$:
385 GOSUB 20000: TT$=IOSTR$
390 IF INSTR(TT$,",")>0 THEN PRINT"No commas in name, please.":GOTO 380
395 IOTTL$="How Many Phases":IOH=7:IOV=6:IOVAL=NC:GOSUB 20000:NC=IOVAL
400 IF NC>12 THEN PRINT"Sorry, no more than 12 Phases.":GOTO 395
405 IOTTL$="How Many Overhead Ground Wires (0,1 or 2)":IOH=9:IOV=6:
410 IOVAL=NE:GOSUB 20000:NE=IOVAL:IF NE>2 THEN BEEP: GOTO 405
415 IOTTL$="Thunder DAY Level (Enter 0 to use Thunder HOUR Level)"
420 IOH=11:IOV=6:IOVAL=TD:GOSUB 20000:TD=IOVAL
425 IF TD=0 THEN IOTTL$="Thunder HOUR Level":IOH=12:IOV=6:IOVAL=TH
430 IF TD=0 THEN GOSUB 20000:TH=IOVAL: TD=FNB(TH)
435 IF NE=0 THEN GOTO 480
440 LOCATE 16,1:PRINT"For Each SHIELDWIRE, ENTER:";
445 IF MM=1 THEN PRINT" (All Distances in Feet)"
450 IF MM=2 THEN PRINT" (All Distances in Meters)"
455 LOCATE 18,1:PRINT" Distance From Centerline       Height Above Ground at Tower"
460 FOR I=1 TO NE
465 IOH=I+18:IOV=10:IOVAL=GX(I):GOSUB 20000:GX(I)=IOVAL
470 IOH=I+18:IOV=40:IOVAL=GY(I):GOSUB 20000:GY(I)=IOVAL
475 NEXT
480 LB$=" D A T A   E N T R Y / E D I T  # 2":GOSUB 16000
485 PRINT"For each PHASE, ENTER:";
490 IF MM=1 THEN PRINT" (All Distances in Feet)"
495 IF MM=2 THEN PRINT" (All Distances in Meters)"
500 LOCATE 5,1
505 PRINT" Distance    Conductor    Insulation    Phase    Phase     AC"
510 PRINT"   From        Height      Striking    Voltage   Angle     or"
515 PRINT"Centerline                 Distance      (kV)    (deg)     DC"
520  FOR I=1 TO NC
525 IOH=I+8:IOV=3:IOVAL=CX(I):GOSUB 20000:CX(I)=IOVAL
530 IOH=I+8:IOV=17:IOVAL=CY(I):GOSUB 20000:CY(I)=IOVAL
535 IOH=I+8:IOV=30:IOVAL=SI(I):GOSUB 20000:SI(I)=IOVAL
540 IOH=I+8:IOV=40:IOVAL=LV(I):GOSUB 20000:LV(I)=IOVAL
545 IOH=I+8:IOV=49:IOVAL=PA(I):GOSUB 20000:PA(I)=IOVAL
550 IOH=I+8:IOV=58:IOSTR$="$$$"+ACDC$(I):GOSUB 20000:ACDC$(I)=IOSTR$
555 IF ACDC$(I)="dc" THEN ACDC$(I)="DC"
560 IF ACDC$(I)="ac" THEN ACDC$(I)="AC"
565 NEXT I
570 GOSUB 24030:REM crude plot of conductor locations
575 LB$=" D A T A   E N T R Y / E D I T  # 3":GOSUB 16000
580 PRINT:PRINT"Shielding Evaluation: Select the highest, outer-most conductors."
585 PRINT"At least one conductor should be checked on each side."
590 IOTTL$="How many conductors should be checked"
595 IOH=6:IOV=1:IOVAL=NX:GOSUB 20000:NX=IOVAL
600 PRINT" INDEX of Exposed Conductor     INDEX of Closest Shield Wire"
605 FOR I=1 TO NX
610 IOH=I+7:IOV=10:IOVAL=MX(I):GOSUB 20000:MX(I)=IOVAL
615 IOH=I+7:IOV=45:IOVAL=MY(I):GOSUB 20000:MY(I)=IOVAL
620 NEXT I
625 LB$=" D A T A   E N T R Y / E D I T  # 4":GOSUB 16000
630 IOTTL$="ENTER: Number of SUBCONDUCTORS in each Bundled Conductor (1-4)"
635 IOH=3:IOV=1:IOVAL=NB:GOSUB 20000:NB=IOVAL:IF NB<1 OR NB>4 GOTO 630
640 PRINT
645 IF MM=1 THEN PRINT "Use INCHES for the following three dimesions:"
650 IF MM=2 THEN PRINT "Use MILLIMETRES for the following three dimesions:"
655 IOH=7:IOV=9:IOTTL$="Subconductor SPACING":IOVAL=BS:GOSUB 20000:BS=IOVAL
660 IOH=9:IOV=9:IOTTL$="Conductor DIAMETER":IOVAL=CD:GOSUB 20000:CD=IOVAL
665 IOH=11:IOV=9:IOTTL$="OHGW DIAMETER":IOVAL=GD:GOSUB 20000:GD=IOVAL
670 PRINT
675 IF MM=1 THEN PRINT "Use FEET for the following three dimesions:"
680 IF MM=2 THEN PRINT "Use METRES for the following three dimesions:"
685 IOTTL$="Average SPAN Length":IOH=15:IOV=9:IOVAL=SP:GOSUB 20000:SP=IOVAL
690 IOTTL$="Conductor Midspan SAG (Enter 0 for our guess)"
695 IOH=17:IOV=9:IOVAL=CS:GOSUB 20000:CS=IOVAL
700 IF CS=0 AND MM=2 THEN CS=.0014*SP*SP/20: REM FOR ACSR CONDUCTORS, 20% RTS 
705 IF CS=0 AND MM=1 THEN CS=2.1336E-05*SP*SP
710 IOTTL$="Overhead Groundwire Midspan SAG (Enter 0 for our guess)"
715 IOH=19:IOV=9:IOVAL=GS:GOSUB 20000:GS=IOVAL
720 IF GS=0 AND MM=2 THEN GS=.0009*SP*SP/20: REM FOR STEEL ShDWIRES, 20% RTS
725 IF GS=0 AND MM=1 THEN GS=1.3716E-05*SP*SP
730 LB$=" D A T A   E N T R Y / E D I T  # 5":GOSUB 16000
735 IOTTL$= "Tower Type (1=Conical,2=H-Frame,3=Cylindrical,4=Waist):"
740 IOH=3:IOV=1:IOVAL=IT:GOSUB 20000:IT=IOVAL:IF IT<1 OR IT>4 THEN BEEP:GOTO 735
745 PRINT:PRINT"ENTER: Tower Dimensions";
750 IF MM=1 THEN PRINT" (All Distances in Feet)"
755 IF MM=2 THEN PRINT" (All Distances in Meters)"
760 IOTTL$="Tower HEIGHT":IOH=6:IOV=5:IOVAL=TW:GOSUB 20000:TW=IOVAL
765 IF IT=3 THEN 785
770 IF IT=2 THEN IOTTL$="Downlead DIAMETER:" ELSE IOTTL$="Tower BASE DIAMETER"
775 IOH=7:IOV=5:IOVAL=TR:GOSUB 20000:TR=IOVAL
780 IF TR<.2 THEN IF MM=1 THEN TR=.656 ELSE TR=.2
785 IF IT=2 THEN IOTTL$="Downlead SEPARATION" ELSE IOTTL$="Tower Midsection WIDTH"
790 IF IT=1 THEN 825
795 IOH=8 :IOV=5:IOVAL=WW:GOSUB 20000:WW=IOVAL
800 IF WW<.2 THEN IF MM=1 THEN WW=.656 ELSE WW=.2
805 IF IT<4 THEN 825
810 IOTTL$="Tower-Top DIAMETER":IOH=9 :IOV=5:IOVAL=TOPR:GOSUB 20000:TOPR=IOVAL
815 IF TOPR<.2 THEN IF MM=1 THEN TOPR=.656 ELSE TOPR=.2
820 IOTTL$="DISTANCE from Middle to Top":IOH=10:IOV=5:IOVAL=TPH:GOSUB 20000:TPH=IOVAL
825 LOCATE 12,1:PRINT"ENTER: Tower Footing Resistance DISTRIBUTION:"
830 PRINT" % of Values GREATER THAN Footing Resistance (ohms)"
835 FOR I=10 TO 1 STEP -1
840 LOCATE 24-I,4:PRINT I*10;"%  >"
845 IOH=24-I:IOV=35:IOTTL$="":IOVAL=RF(I):GOSUB 20000:RF(I)=IOVAL
850 NEXT I
855 REM--------------------------------------
860 REM END OF EDITING - RETURN TO MAIN MENU
865 REM--------------------------------------
870 GOTO 265
1000 REM-------------------
1005 REM START OF PROGRAM 
1010 REM-------------------
1015 LB$=" D A T A   S T O R A G E ":GOSUB 16000
1020 IOTTL$="Do you want to SAVE this data to a DISK FILE? (Y/N)"
1025 IOSTR$="$$$Y":IOH=3:IOV=1:GOSUB 20000:B$=IOSTR$
1030 IF B$="Y" OR B$="y" THEN INPUT"Enter the DISK FILE NAME <filenm.ext>";F$:B$="Y":GOSUB 13000:REM save edited data file
1035 IOTTL$="Do you want to SAVE output to a DISK FILE? (Y/N)"
1040 IOSTR$="$$$Y":IOH=6:IOV=1:GOSUB 20000:B$=IOSTR$
1045 IF B$="Y" OR B$="y" THEN INPUT"Enter the DISK FILE NAME <filenm.ext>";F$:B$="Y":FSA=0:GOSUB 25000:REM open output data file
1050 REM --Routine to convert English units to Metric
1055 IF MM=2 THEN 1515
1060 FOR I=1 TO NC
1065  CX(I)=CX(I)/3.28:CY(I)=CY(I)/3.28:SI(I)=SI(I)/3.28
1070 NEXT I
1075 FOR I=1 TO NE
1080  GX(I)=GX(I)/3.28:GY(I)=GY(I)/3.28
1085 NEXT I
1090 BS=BS/39.37:CD=CD*25.4:GD=GD*25.4
1095 TW=TW/3.28:TR=TR/3.28:WW=WW/3.28:TPH=TPH/3.28
1100 SP=SP/3.28:CS=CS/3.28:GS=GS/3.28
1500 REM-------------------------
1505 REM  SHIELDING CALCULATION
1510 REM-------------------------
1515 LB$=" S H I E L D I N G   C A L C U L A T I O N ":GOSUB 16000
1520 IF FSA=1 THEN GOSUB 25500 : REM save title to disk
1525 IF NE=0 THEN GOTO 2000:REM UNSHIELDED CASE
1530 REM STEP---1.4--- AVERAGE HEIGHT OF SHIELDWIRE
1535 GY=0:FOR I=1 TO NE: GY=GY+GY(I): NEXT I: GY=GY/NE
1540 EM=GY-(2/3)*GS
1545 REM STEP---1.5---TOTAL FLASHES TO LINE
1550 GF=FNA(TD)
1555 RN=GF/10*(ABS(GX(1)-GX(2))+FNW(EM))
1560 REM GF IN STROKES/SQ.KM; RN IN STROKES /100 KM
1565 REM STEP---1.6---FLASHOVER OF MOST EXPOSED CONDUCTOR
1570 SN=0
1575 FOR I=1 TO NX
1580  MX=MX(I):MY=MY(I)
1585  FV=FND(SI(MX))
1590 REM STEP---1.7---MEAN HEIGHT OF PHASE CONDUCTOR
1595  RH=CY(MX)-(2/3)*CS
1600 REM STEP---1.7A---CALCULATE BETA FROM PHASE CONDUCTOR HEIGHT 01/86
1605 IF I<>1 THEN 1670
1610 IOTTL$="Value of BETA (Enter 0 for our guess)"
1615 IOH=3:IOV=1:IOVAL=BE:GOSUB 20000:BE=IOVAL
1620 IF BE<>0 THEN 1665
1625  BE=22/RH
1630  IF BE>.9 THEN BE=.9
1635  IF BE<.6 THEN BE=.6
1640 LOCATE 5,1:PRINT"Our guess of BETA = ";BE
1645 IOTTL$="Accept (Y/N)"
1650 IOSTR$="$$$Y":IOH=6:IOV=1:IOVAL=0:GOSUB 20000:B$=IOSTR$
1655 IF B$<>"Y" AND B$<>"y" AND B$<>"N" AND B$<>"n" THEN 1645
1660 IF B$="N" OR B$="n" THEN INPUT "Enter NEW value of BETA";BE
1665 IF FSA=1 THEN PRINT#1,"Value of BETA used =";BE
1670 REM STEP---1.8---CORONA RADIUS
1675  CVOLTAGE=FV:CHEIGHT=RH:GOSUB 5000:RC=CRADIUS
1680 REM STEP---1.9-10---EQUIVALENT RADIUS OF BUNDLE
1685  GOSUB 5500
1690  IF NB=1 THEN 1705
1695  RC=RC+EC
1700 REM STEP---1.11-12---EFFECTIVE SELF SURGE IMPEDANCE OF CONDUCTOR
1705  SZ=60*SQR(LOG(2*RH/EC)*LOG(2*RH/RC))
1710  IN=2*FV/SZ
1715 REM STEP---1.13---STRIKING DISTANCE
1720  SD=FNS(IN)
1725 REM STEP---1.14-15---COORDINATE OF SHIELD WIRE FOR GOOD SHIELDING
1730  X1=SD^2-(BE*SD-RH)^2
1735  IF X1<=0 THEN 1755
1740  X2=SD^2-(BE*SD-EM)^2
1745  IF X2<=0 THEN 1755
1750  GOTO 1770
1755 PRINT"IN THIS CASE, GOOD SHIELDING CAN ONLY BE ACHIEVED BY HAND CALCULAT."
1760 IF FSA=1 THEN PRINT#1,"IN THIS CASE, GOOD SHIELDING CAN ONLY BE ACHIEVED BY HAND CALCULAT."
1765  GOTO 1970
1770  XG=SQR(X2)-SQR(X1)
1775 REM STEP---1.16---EFFECTIVE SHIELD ANGLE
1780  AL=ATN(XG/(EM-RH))
1785  TM=ABS(CX(MX)-GX(MY))/(EM-RH)
1790  AS1=ATN(TM)
1795  IF ABS(GX(MY))>ABS(CX(MX)) THEN AS1=ATN(-TM)
1800  IF (AS1-AL)<=0 THEN 1910
1805  IF (AS1-AL)>0 THEN 1815
1810 REM STEP---1.17---COMPUTE UNCOVERED WIDTH
1815  IF AS1<=0 THEN 1910
1820  F=SQR((CX(MX)-GX(MY))^2+(RH-EM)^2)
1825  AO=F/(2*SD)
1830  A1=ABS(AS1)-(-ATN(AO/SQR(-AO*AO+1))+PI/2)
1835  A2=(BE*SD-RH)/SD
1840  IF (BE*SD)<RH THEN 1855
1845  XS=SD*COS(ATN(A2/SQR(1-A2*A2)))+SD*SIN(A1)
1850  GOTO 1865
1855  XS=SD+SD*SIN(A1)
1860 REM STEP---1.18---MAXIMUM STRIKE DISTANCE THAT CAN OCCUR
1865  YO=(EM+RH)/2
1870  SM=ABS((1/(TM/SQR(1+TM^2)-BE))*(-YO))
1875 REM STEP---1.19-20---COMPUTE IMAXIMUM
1880  IX=.041*SM^1.538
1885 REM STEP---1.21-24---TOTAL LINE SHIELDING FAILURES
1890  IINPUT=IN:GOSUB 18000:PB=PIGRIN
1895  IINPUT=IX:GOSUB 18000:P1=PIGRIN
1900  AF=(GF/10)*XS*(PB-P1)/2
1905  SN=SN+AF
1910  AL=AL*180/PI
1915  AL=INT(AL*100)/100
1920  AS1=AS1*180/PI
1925  AS1=INT(AS1*100)/100
1930  PRINT
1935  PRINT using"THE SHIELD ANGLE REQUIRED FOR CONDUCTOR ##  IS =  ####.##  DEGREES";MX,AL
1940  PRINT using"THE ACTUAL SHIELD ANGLE FOR CONDUCTOR   ##  IS =  ####.##  DEGREES";MX,AS1
1945 IF FSA<>1 GOTO 1965
1950  PRINT#1,"THE SHIELD ANGLE REQUIRED FOR CONDUCTOR ";MX;" IS ";AL;" DEGREES"
1955  PRINT#1,"THE ACTUAL SHIELD ANGLE FOR CONDUCTOR   ";MX;" IS ";AS1;" DEGREES"
1960  PRINT#1," "
1965 NEXT I
1970 GOTO 2100
2000 REM--------SIMPLE CALCULATION FOR UNSHIELDED LINE--------
2005 ILEFT=0:IRIGHT=0:HLEFT=0:HRIGHT=0
2010 FOR I=1 TO NC
2015  IF CX(I)>0 AND CY(I) > HRIGHT THEN  HRIGHT=CY(I):IRIGHT=I
2020  IF CX(I)<=0 AND CY(I) > HLEFT THEN  HLEFT=CY(I):ILEFT=I
2025 NEXT I
2030 HAVG=.5*(HRIGHT+HLEFT)-2/3*CS
2035 B=CX(IRIGHT)-CX(ILEFT)
2040 GF=FNA(TD)/10*(B+FNW(HAVG))
2045 CHEIGHT=HAVG
2050 CVOLTAGE=.5*(FND(SI(ILEFT)) + FND(SI(IRIGHT)) )
2055 GOSUB 5000
2060 GOSUB 5500
2065 IF NB>1 THEN CRADUIS=CRADIUS+EC
2070 SZ=60*SQR(LOG(2*HAVG/EC) * LOG(2*HAVG/CRADIUS))
2075 IINPUT=2*CVOLTAGE/SZ
2080 GOSUB 18000
2085 SN=PIGRIN*GF
2090 PRINT"With No Shield Wires, the Tripout Rate Is";SN;" Per 100 km-yr." 
2095 IF FSA=1 THEN PRINT#1,"With No Shield Wires, the Tripout Rate Is";SN;" Per 100 km-yr.":PRINT
2100 PRINT:PRINT"Press Any Key to Continue."
2105 A$=INPUT$(1)
2500 REM-------------------------
2505 REM  BACKFLASH CALCULATION
2510 REM-------------------------
2515 LB$=" B A C K F L A S H   C A L C U L A T I O N ":GOSUB 16000
2520 IF FSA=1 THEN GOSUB 25500 : REM save title to disk
2525 SSSUM=0
2530 IF NE=0 THEN GOTO 4030
2535 REM STEP--2.1-2--- FLASHOVER VOLTAGE AT 2 & 6 MICROSECONDS
2540 FOR I=1 TO NC
2545  F2(I)=FNC(SI(I))
2550  F6(I)=FND(SI(I))
2555 NEXT I
2560 REM-----------------------------------
2565 REM START OF FOOTING RESISTANCE LOOP
2570 REM-----------------------------------
2575 FOR FOOTR = 1 TO 10
2580 FR=RF(FOOTR)
 PRINT:PRINT using"Footing RESISTANCE   = ####.##   Ohms.";FR
2590 IF FSA=1 THEN PRINT#1,using"Footing RESISTANCE   = ####.##   Ohms.";FR
2595 REM STEP---2.3---TOWER-TOP VOLTAGE
2600 TV=1.8*F2(1)
2605 REM STEP---2.4--SHIELDWIRE CORONA DIAMETER
2610 CVOLTAGE=TV:CHEIGHT=GY:GOSUB 5000:RC=CRADIUS
2615 REM PRINT"Radius of CORONA SHEATH around SHIELDWIRE =";RC;" Meters"
2620 REM STEP---2.5---SELF SURGE IMPEDANCE OF EACH SHIELDWIRE
2625 GZ=60*SQR(LOG(2*GY/(GD/2000))*LOG(2*GY/RC))
2630 REM STEP---2.6---COMBINED SURGE IMPEDANCE
2635 IF NE<>1 THEN 2650
2640 GC=GZ
2645 GOTO 2670
2650 AM=(GX(1)-GX(2))^2+(2*GY)^2
2655 BM=(GX(1)-GX(2))^2
2660 GM=60*LOG(SQR(AM/BM))
2665 GC=(GZ+GM)/2
2670 REM PRINT"Combined SURGE IMPEDANCE of SHIELD WIRES =";INT(GC*100)/100;" Ohms"
2675 REM STEP---2.7---MUTUAL IMPEDANCE BETWEEN CONDUCTORS & SHIELDWIRES
2680 FOR I=1 TO NE
2685  FOR J=1 TO NC
2690   AM=(CX(J)-GX(I))^2+(CY(J)+GY(I))^2
2695   BM=(CX(J)-GX(I))^2+(CY(J)-GY(I))^2
2700   CZ(J,I)=60*LOG(SQR(AM/BM))
2705  NEXT J
2710 NEXT I
2715 REM STEP---2.7B---COUPLING FACTORS
2720  FOR N=1 TO NC
2725  IF NE<>1 THEN 2740
2730  CF(N)=CZ(N,1)/GC
2735  GOTO 2745
2740  CF(N)=(CZ(N,1)+CZ(N,2))/(2*GC)
2745  NEXT N
2750 REM STEP---2.8, 2.9  TOWER SURGE RESPONSE
2755 ON IT GOTO 2765,2780,2815,2835
2760 REM--- CLASS 1, SARGENT CONE ---
2765 ZT=30*LOG(2*(TW^2+(TR/2)^2)/(TR/2)^2)
2770 TU=TW/(VL*.85): REM Travel Time in us
2775 GOTO 2870
2780 REM--- CLASS 2, H-FRAME BASED ON SURFACE AREA ---
2785 Z1=60*LOG(5.657*TW/TR)-60: T1=TW/VL
2790 Z2= (WW*60*LOG(4*TW/TR) + TW*Z1) / (WW+TW) : T2=(WW+TW)/VL
2795 LT=T1*Z1*T2*Z2/( T1*Z1 + T2*Z2)
2800 ZT=Z1*Z2/(Z1+Z2)
2805 TU=LT/ZT
2810 GOTO 2870
2815 REM--- CLASS 3, HILEMAN CYLINDER ---
2820 ZT=60*LOG(5.657*TW/WW)-60
2825 TU=TW/(VL*.85)
2830 GOTO 2870
2835 REM--- CLASS 4, CHISHOLM WAIST --- 
2840 Z2=.5* (TOPR*TPH + WW*TW + TR*(TW-TPH)) / (TW*TW)
2845 Z2 = .5*ATN(Z2)
2850 Z1 = 60*LOG(1/TAN(Z2)) - 60*LOG(SQR(2))
2855 ZT = SQR(PI/4) * Z1: REM Because it is SQUARE not ROUND.
2860 TU=TW/(VL*.85)
2865 GOTO 2870
2870 REM PRINT"Tower SURGE IMPEDANCE = ";INT(ZT*100)/100;"Ohms"
2875 REM PRINT"Tower TRAVEL TIME =";INT(TU*100)/100;" us"
2880 REM STEP---2.10---SPAN TRAVEL TIME
2885 TS=SP/(VL*.9)
2890 REM STEP---2.11---TRAVEL TIME TO EACH CROSSARM
2895 FOR I=1 TO NC
2900  TA(I)=(TW-CY(I))/(VL*.85)
2905 NEXT I
2910 REM STEP---2.12-13---INTRINSIC CIRCUIT IMPEDANCE
2915 ZI=(GC*ZT)/(GC+2*ZT)
2920 REM STEP---2.14---TOWER WAVE IMPEDANCE
2925 ZW=(2*ZT*(GC^2)/(GC+2*ZT)^2)*(ZT-FR)/(ZT+FR)
2930 PRINT using"Tower WAVE IMPEDANCE = ####.##   Ohms.";ZW
2935 IF FSA=1 THEN PRINT#1, using"Tower WAVE IMPEDANCE = ####.##   Ohms.";ZW
2940 REM STEP---2.15---TOWER DAMPING FACTOR
2945 PS=(2*ZT-GC)/(2*ZT+GC)*(ZT-FR)/(ZT+FR)
2950 BETAS=(2*ZT-GC)/(2*ZT+GC)
2955 REM STEP---2.16---FOOTING RESISTANCE DAMPING FACTOR
2960 AP=(2*FR)/(ZT+FR)
2965 REM STEP---2.17-19---TOWER TOP VOLTAGE
2970 V2=ZI-ZW*(1-TU/(1-PS))/(1-PS)
2975 IF TS<1 THEN 2990
2980 VT=0
2985 GOTO 2995
2990 VT=(-4*.85*V2^2/GC)*(1-2*V2/GC)*(1-TS)
2995 V2=V2+VT
3000 REM STEP---2.20---VOLTAGE ACROSS FOOTING RESISTANCE AT 2 MICROSECONDS
3005 VW=AP*ZI*(1-(PS*TU)/(1-PS))/(1-PS)
3010 REM STEP---2.21---REDUCE THE VOLTAGE ACROSS FOOTING RESISTANCE BY REFL.
3015 VW=VW+VW*VT/V2
3020 REM STEP---2.22---CROSSARM VOLTAGES AT 2 MICROSECONDS
3025 FOR I=1 TO NC
3030  VC(I)=VW+((TU-TA(I))/TU)*(V2-VW)
3035 NEXT I
3040 REM STEP---2.23---INSULATOR VOLTAGE AT 2 MICROSECONDS
3045 FOR I=1 TO NC
3050  VI(I)=VC(I)-CF(I)*V2
3055 NEXT I
3060 REM STEP---2.24---TOWER TOP VOLTAGE AT 6 MICROSECONDS
3065 V6=GC*FR/(GC+2*FR)
3070 REM STEP---2.25---REFLECTED VOLTAGE AT 6 MICROSECONDS
3075 D9=FR/(GC+2*FR)
3080 VV=-4*.85*GC*(D9^2)*(1-2*D9)
3085 REM STEP---2.26---INSULATOR VOLTAGE AT 6 MICROSECONDS
3090 FOR I=1 TO NC
3095  VS(I)=(V6+VV)*(1-CF(I))
3100 NEXT I
3105 REM STEP---2.27---CRITICAL STROKE CURRENT AT 2 MICROSECONDS
3110 FOR I=1 TO NC
3115  I2(I)=F2(I)/VI(I)
3120 NEXT I
3125 REM STEP---2.28---CRITICAL STROKE CURRENT AT 6 MICROSECONDS
3130 FOR I=1 TO NC
3135  I6(I)=F6(I)/VS(I)
3140 REM STEP---2.29-30---SELECT LOWEST CRITICAL CURRENT
3145  IF I2(I)<I6(I)  THEN IS(I)=I2(I):VR(I)=F2(I)
3150  IF I2(I)>=I6(I) THEN IS(I)=I6(I):VR(I)=F6(I)
3155  IU(I)=INT(IS(I)*100)/100
3160  VJ(I)=INT(VI(I)*100)/100
3165  VP(I)=INT(VS(I)*100)/100
3170 NEXT I
3175 PRINT
3180 PRINT"Cond.   Coupling   Flashover  Insulator   Flashover  Insulator   Critical"
3185 PRINT" No.     Factor     Voltage    Voltage     Voltage    Voltage    Current"
3190 PRINT"                    at 2 us    at 2 us     at 6 us    at 6 us"
3195 PRINT"                      (kV)     (kV/kA)       (kV)     (kV/kA)     (kA)"
3200 IF FSA<>1 GOTO 3230
3205 PRINT#1," "
3210 PRINT#1,"Cond.   Coupling   Flashover  Insulator   Flashover  Insulator   Critical"
3215 PRINT#1," No.     Factor     Voltage    Voltage     Voltage    Voltage    Current"
3220 PRINT#1,"                    at 2 us    at 2 us     at 6 us    at 6 us"
3225 PRINT#1,"                      (kV)     (kV/kA)       (kV)     (kV/kA)     (kA)"
3230 FOR I=1 TO NC
3235  PRINT USING" ##      #.####       ####      ##.##        ####      ##.##      ###.##";I,CF(I),F2(I),VJ(I),F6(I),VP(I),IU(I)
3240 IF FSA=1 THEN PRINT#1, USING" ##      #.####       ####      ##.##        ####      ##.##      ###.##";I,CF(I),F2(I),VJ(I),F6(I),VP(I),IU(I)
3245 NEXT I
3250 REM STEP---2.31---FIND EQUATION  FOR  CRITICAL CURRENT
3255 FOR I=1 TO 36: SV(I)=SIN((I*10-5)*PI/180):NEXT I
3260 PV=SQR(2/3):REM for converting p-p to p-gnd voltage
3265 FOR I=1 TO NC+1
3270  A(I)=1
3275  PR(I)=0
3280  FOR J=1 TO 10
3285   KS(I,J)=0
3290   KE(I,J)=0
3295  NEXT J
3300 NEXT I
3305 LA=NC+1
3310  FOR K=5 TO 360 STEP 10
3315  IL=2000:REM initial guess of min current in kA
3320  FOR J=1 TO NC
3325   CC=(K+PA(J))/10
3330   IF CC<0  THEN CC=CC+36:GOTO 3330
3335   IF CC>36 THEN CC=CC-36:GOTO 3335
3340   PH=SV(CC)
3345   IF ACDC$(J)="AC" THEN IR(J)=IS(J)*(1-PV*PH*LV(J)/VR(J))
3350   IF ACDC$(J)="DC" THEN IR(J)=IS(J)*(1-COS(PI*PA(J)/180)*LV(J)/VR(J))
3355   IF IR(J) <= IL THEN IL=IR(J):NO=J
3360  NEXT J
3365  PR(NO)=PR(NO)+1
3370  B=A(LA)
3375  IF (LA-NO)=0 THEN 3405
3380  KE(LA,B)=K-5
3385  A(NO)=A(NO)+1
3390  BB=A(NO)
3395  KS(NO,BB)=K-5
3400  LA=NO
3405 NEXT K
3410 KE(LA,BB)=K-5
3415 REM STEP---2.32---% OF TIME EACH PHASE IS DOMINATING
3420 PRINT:PRINT"The PROBABILITY of BACKFLASHOVER by each PHASE is:"
3425 PRINT" Cond. No.      Probability (%)"
3430 FOR I=1 TO NC
3435  PR(I)=(PR(I)/36)*100
3440  PRINT USING"   ##              ###.#";I,PR(I)
3445 NEXT I
3450 PRINT
3455 REM STEP---2.33---AVERAGE VALUE OF CURRENT  FOR  EACH PHASE
3460 FOR I=1 TO NC
3465  SU(I)=0
3470  SA(I)=0
3475  IA=A(I)
3480  IF IA<>1 THEN 3495
3485  IC(I)=0
3490  GOTO 3540
3495  FOR J=2 TO IA
3500   T2=(KE(I,J)+PA(I))*PI/180
3505   T1=(KS(I,J)+PA(I))*PI/180
3510   TH(J)=(T2-T1)
3515   IA(J)=IS(I)*(1+(PV*LV(I)/VR(I))*(COS(T2)-COS(T1))/TH(J))
3520   SU(I)=SU(I)+IA(J)*TH(J)
3525   SA(I)=SA(I)+TH(J)
3530  NEXT J
3535  IC(I)=SU(I)/SA(I)
3540 NEXT I
3545 IF FSA<>1 GOTO 3580
3550 PRINT#1," ":PRINT#1,"The PROBABILITY of BACKFLASHOVER by each PHASE is:"
3555 PRINT#1," Cond. No.      Probability (%)       Average Critical Current(kA)"
3560 FOR I=1 TO NC
3565 PRINT#1, USING"   ##              ###.#                       ###.##";I,PR(I),IC(I)
3570 NEXT I
3575 PRINT#1," ":PRINT#1,STRING$(80,"-")
3580 REM STEP---2.34---PROBABILITY THAT STROKE CURRENT IS EXCEEDED
3585 FOR I=1 TO NC
3590  IF IC(I)>0 THEN 3605
3595  PX(I)=0
3600  GOTO 3620
3605  IINPUT=IC(I)
3610  GOSUB 18000
3615  PX(I)=PIGRIN
3620 NEXT I
3625 REM STEP---2.35---EFFECTIVE TOWER FLASHES
3630 EF=.6*RN
3635 REM STEP---2.36-38---TOWER FLASHES/PHASE/100KM-YEARS
3640 SS=0
3645 FOR I=1 TO NC
3650  ET(I)=EF*PR(I)*PX(I)/100
3655  SS=SS+ET(I)
3660 NEXT I
3665 SS=INT(SS*100)/100
3670 REM---------------------------------------------------
3675 REM  UPDATE BACKFLASH SUM AND CONTINUE WITH NEXT RF(I)
3680 REM---------------------------------------------------
3685 SSSUM=SSSUM + SS/10
3690 NEXT FOOTR
3695 PRINT"Press Any Key to Continue."
3700 A$=INPUT$(1)
4000 REM-----------------
4010 REM  FIANL RESULTS
4020 REM-----------------
4030 LB$=" F I N A L   R E S U L T S ":GOSUB 16000:PRINT
4040 IF FSA=1 THEN GOSUB 25500 : REM save title to disk
4050 PRINT"*****************************************************************"
4060 PRINT
4070 PRINT using"  THE BACKFLASHOVER RATE = ###.###  FLASHOVERS/100 KM-YEARS";SSSUM
4080 SV=INT(SSSUM*161)/100
4090 PRINT using"                         = ###.###  FLASHOVERS/100 MI-YEARS";SV
4100 PRINT
4110 PRINT "  THE SHIELDING FAILURE"
4120 SN=INT(SN*100)/100
4130 PRINT using"          FLASHOVER RATE = ###.###  FLASHOVERS/100 KM-YEARS";SN
4140 SB=INT(SN*161)/100
4150 PRINT using"                         = ###.###  FLASHOVERS/100 MI-YEARS";SB
4160 PRINT
4170 PRINT using"  TOTAL FLASHOVER RATE   = ###.###  FLASHOVERS/100 KM-YEARS";SSSUM+SN
4180 PRINT using"                         = ###.###  FLASHOVERS/100 MI-YEARS";(SV+SB)
4190 PRINT
4200 PRINT"*****************************************************************"
4210 PRINT"HIT ANY KEY FOR MAIN MENU"
4220 A$=INPUT$(1)
4230 IF FSA<>1 GOTO 4380
4240 PRINT#1,"*****************************************************************"
4250 PRINT#1," "
4260 PRINT#1, using"  THE BACKFLASHOVER RATE = ###.###  FLASHOVERS/100 KM-YEARS";SSSUM
4270 PRINT#1, using"                         = ###.###  FLASHOVERS/100 MI-YEARS";SV
4280 PRINT#1," "
4290 PRINT#1,"  THE SHIELDING FAILURE"
4300 PRINT#1, using"          FLASHOVER RATE = ###.###  FLASHOVERS/100 KM-YEARS";SN
4310 PRINT#1, using"                         = ###.###  FLASHOVERS/100 MI-YEARS";SB
4320 PRINT#1," "
4330 PRINT#1, using"  TOTAL FLASHOVER RATE   = ###.###  FLASHOVERS/100 KM-YEARS";SSSUM+SN
4340 PRINT#1, using"                         = ###.###  FLASHOVERS/100 MI-YEARS";(SV+SB)
4350 PRINT#1," "
4360 PRINT#1,"*****************************************************************"
4370 CLOSE#1
4380 IF MM=1 THEN GOSUB 26000
4390 FSA=0:CLS: GOTO 265
5000 REM-------------------------------
5010 REM  CORONA RADIUS DETERMINATION
5020 REM-------------------------------
5030 REM   Inputs: CHEIGHT (m) and CVOLTAGE (kV)
5040 REM   Output: CRADIUS (m)
5050 REM-------------------------------
5060 CRADIUS=.2
5070 FOR ICOR=1 TO 6
5080  D2=CVOLTAGE/(1500*LOG(2*CHEIGHT/CRADIUS))
5090  DELRC=ABS(D2-CRADIUS)
5100  CRADIUS=D2
5110 NEXT ICOR
5120 IF DELRC > .002 GOTO 5070
5130 RETURN
5500 REM-----------------------------
5510 REM  BUNDLE RADIUS CALCULATION
5520 REM-----------------------------
5530 ON NB GOTO 5550,5570,5590,5610
5540 PRINT "Cannot accept more than 4 conductors, 4 conductor bundle assumed":GOTO 5610
5550 BU=CD/2000
5560 GOTO 5620
5570 BU=SQR(CD/2000000!*BS)
5580 GOTO 5620
5590 BU=(CD/2E+09*BS*BS)^(1/3)
5600 GOTO 5620
5610 BU=(SQR(2)*CD/2E+12*BS^3)^.25
5620 EC=BU
5630 RETURN
12000 REM---------------------------------------------------
12010 REM  INPUT LINE PARAMETERS FROM FILE IN SELECTED DRIVE
12020 REM---------------------------------------------------
12030 LB$=" I N P U T   F R O M   D I S K   F I L E":GOSUB 16000
12040 PRINT:PRINT "Insert Line Parameter Disk Into DRIVE ";DN$
12050 PRINT"Press any key to continue.":AQ$=INPUT$(1)
12060 PRINT:INPUT "Type the FILE NAME as <filenm.ext> and press RETURN.(! for dir)";FF$:CUR.COL=CSRLIN
12070 IF FF$="!" THEN PRINT:PRINT:PRINT"Current Drive":FILES DN$+":*.*":CUR.COL=CSRLIN: GOTO 12060
12080 IF FF$="" THEN GOTO 12060
12090 OPEN DN$+":"+FF$ FOR INPUT AS #3
12100 INPUT#3,TT$
12110 INPUT#3,MM,NC,NE
12120 FOR I=1 TO NC:INPUT#3,CX(I),CY(I),SI(I),LV(I),PA(I),ACDC$(I): NEXT I
12130 FOR I=1 TO NE:INPUT#3,GX(I),GY(I): NEXT I
12140 INPUT#3,NX
12150 FOR I=1 TO NX:INPUT#3,MX(I),MY(I):NEXT I
12160 REM INPUT#3,BE
12170 INPUT#3,NB,BS,CD,CS
12180 INPUT#3,GD,GS,SP,TD
12190 INPUT#3,IT,TW,TR,WW,TPH,TOPR
12200 FOR I=1 TO 10:INPUT#3,RF(I):NEXT I
12210 CLOSE #3
12220 RETURN
13000 REM----------------------------------------------------
13010 REM  WRITE LINE PARAMETERS TO FILE F$ IN SELECTED DRIVE
13020 REM----------------------------------------------------
13030 LB$=" W R I T E   T O   D I S K   F I L E":GOSUB 16000
13040 PRINT "Insert line parameter disk into DRIVE ";DN$
13050 PRINT"Press any key to continue.":AQ$=INPUT$(1)
13060 PRINT:PRINT "Saving data to file ";DN$;":";F$
13070 OPEN DN$+":"+F$ FOR OUTPUT AS #2
13080 PRINT#2,TT$
13090 PRINT#2,MM,NC,NE
13100 FOR I=1 TO NC:PRINT#2,CX(I),CY(I),SI(I),LV(I),PA(I),ACDC$(I): NEXT I
13110 FOR I=1 TO NE:PRINT#2,GX(I),GY(I): NEXT I
13120 PRINT#2,NX
13130 FOR I=1 TO NX:PRINT#2,MX(I),MY(I):NEXT I
13140 REM PRINT#2,BE
13150 PRINT#2,NB,BS,CD,CS
13160 PRINT#2,GD,GS,SP,TD
13170 PRINT#2,IT,TW,TR,WW,TPH,TOPR
13180 FOR I=1 TO 10:PRINT#2,RF(I):NEXT I
13190 CLOSE #2
13200 RETURN
14000 REM------------------------------
14010 REM  DISPLAY OF DATA FOR REVIEW
14020 REM------------------------------
14030 LB$=" D A T A   R E V I E W ":GOSUB 16000:LC=0:DD=1:GOTO 14100
14040 LB$=" S U M M A R Y   O F   D A T A ":GOSUB 16000
14050 IOTTL$="Do You Wish The Summary Displays on (1) Screen or on (2) Printer"
14060 IOH=3:IOV=1:DD=1:IOVAL=DD:GOSUB 20000: DD=IOVAL
14070 IF DD<1 OR DD>2 THEN BEEP:GOTO 14050
14080 IF DD=1 THEN 14030
14090 LOCATE 10,1:PRINT"Make sure the printer is ready and press any key to continue":A$=INPUT$(1)
14100 IF DD=2 THEN DEV$="LPT1:" ELSE DEV$="SCRN:"
14110 OPEN DEV$ FOR OUTPUT AS #1
14120 IF DD=2 THEN PRINT#1, STRING$(INT(LBLEN/2+.6),"-");LB$;STRING$(INT(LBLEN/2),"-")
14130 PRINT#1,"LINE NAME IS ";TT$:GOSUB 14390
14140 PRINT#1,"#CONDS=";NC;TAB(40)"#SW=";NE:GOSUB 14390
14150 PRINT#1, "COND #   X DIST   HEIGHT   INS LN   PH VLT  PH ANGL ACDC":GOSUB 14390
14160 FOR I=1 TO NC
14170 PRINT#1, USING "  ##     ###.##   ###.##    ##.##    ###     ####    \\";I,CX(I),CY(I),SI(I),LV(I),PA(I),ACDC$(I)
14180 NEXT I
14190 PRINT#1,"SHIELDWIRE #   X DIST   HEIGHT":GOSUB 14390
14200 FOR I=1 TO NE
14210  PRINT#1, USING "    ##         ###.##   ###.##";I,GX(I),GY(I):GOSUB 14390
14220 NEXT I
14230 PRINT#1,"OHGW DIA";GD;TAB(20)"OHGW SAG";GS;TAB(47)"SPAN";SP:GOSUB 14390
14240 PRINT#1,"COND DIA";CD;TAB(20)"COND SAG";CS;TAB(47)"# SUBCOND";NB;TAB(62)"BUND SP";BS:GOSUB 14390
14250 IF IT=4 THEN PRINT#1, "TWR-TOP DIA";TOPR;TAB(20)"MID-TOP HT";TPH
14260 PRINT#1,"# OF EXPOSED CONDUCTORS FOR EVALUATION =";NX:GOSUB 14390
14270 PRINT#1,"CONDUCTORS ARE:";:FOR I=1 TO NX:PRINT #1,TAB(20+5*I);MX(I);:NEXT I:PRINT#1,"":GOSUB 14390
14280 PRINT#1,"CRSPD OHGW ARE :";:FOR I=1 TO NX:PRINT #1,TAB(20+5*I);MY(I);:NEXT I: PRINT#1,"":GOSUB 14390
14290 PRINT#1,"THUNDER DAY LEVEL";TD;TAB(40)"ENGLISH(1) OR METRIC(2)";MM
14300 PRINT#1,"FOOTING RESISTANCE DIST'N"
14310 CUR.COL=CSRLIN
14320 IF DEV$="lpt1:" THEN 14350
14330 FOR I=10 TO 1 STEP -1:LOCATE CUR.COL,(10-I)*8+1:PRINT#1,I*10;"% > ": NEXT I:GOSUB 15000
14340 FOR I=10 TO 1 STEP -1:LOCATE CUR.COL+1,(10-I)*8+1:PRINT#1, USING "###.##";RF(I): NEXT I:GOSUB 15000:GOTO 14360
14350 FOR I=10 TO 6 STEP -1:PRINT #1,USING "### % > ###.##                    ### % > ###.##"; I*10;RF(I);(I-5)*10;RF(I-5):NEXT I
14360 CLOSE#1
14370 LOCATE 24,1:PRINT"Press any key to continue";A$=INPUT$(1)
14380 GOTO 265
14390 IF DEV$="scrn:" THEN GOSUB 15000
14400 RETURN
15000 REM-----------------------------------
15010 REM COUNT LINES FOR OUTPUT FORMATTING
15020 REM-----------------------------------
15030 LC=LC+1:IF LC>23 THEN PRINT"HIT ANY KEY TO CONTINUE.":A$=INPUT$(1):GOSUB 16000:LC=0
15040 RETURN
16000 REM--------------------------
16010 REM  PRINT HEADER AND FOOTER
16020 REM--------------------------
16030 CLS:KEY OFF:LOCATE 25,1:PRINT"FLASH 1.6 1/90"TAB(18);DATE$;SPC(2);TIME$
16040 LBLEN=80-LEN(LB$)
16050 LOCATE 1,1:PRINT STRING$(INT(LBLEN/2+.6),"-");LB$;STRING$(INT(LBLEN/2),"-")
16060 LOCATE 25,44:PRINT"PrtSc key --> PRINTED COPY of Screen";
16070 LOCATE 2,1
16080 RETURN
17000 REM------THE FOLLOWING IS A LIST OF ALL VARIABLES USED IN FLASH 1.4----
17005 REM---- A1 ---- Angle Used In Computing Uncovered Width
17010 REM---- A2 ---- Angle Used In COmputing UNcovered Width
17015 REM---- A$ ---- Printed Copy Selection
17020 REM---- A(I) -- Array Used In Computing Critical Current
17025 REM---- ACDC$(12) - AC or DC? Note 180-deg phase for DC = negative
17030 REM---- AF ---- Number of Shielding Failures
17035 REM---- AL ---- Effective Shield Angle
17040 REM---- AM ---- Variable Used In Computing Mutual Impedances
17045 REM---- AO ---- Variable Used In Computing Uncovered Width
17050 REM---- AP ---- Footing Resistance Damping
17055 REM---- AQ ---- Disk Placement Selection
17060 REM---- AS1---- Actual Shield Angle
17065 REM---- B  ---- A(I)
17070 REM---- B$ ---- Data Save Selection
17075 REM---- BB ---- A(I)
17080 REM---- BE ---- Beta Factor
17085 REM---- BM ---- Variable Used In Computing Mutual Impedances
17090 REM---- BS ---- Bundle Spacing
17095 REM---- BU ---- Equivalent Bundle Radius
17100 REM---- CC ---- Test Variable For Critical Current
17105 REM---- CD ---- Conductor Diameter, mm 
17110 REM---- CF(N) - Coupling Factor
17115 REM---- CS ---- Conductor Midspan Sag
17120 REM---- CX(I) - Conductor Horizontal Distance
17125 REM---- CY(I) - Conductor Vertical Distance
17130 REM---- CZ(I) - Mutual Impedance Among Conductors
17135 REM---- D2 ---- Dummy Variable Used In Computing Corona Radius
17140 REM---- D9 ---- Dummy Variable Used In Computing Reflected Voltage
17145 REM---- DN$ --- Disk Drive Selection
17150 REM---- EC ---- Equivalent Bundle Radius
17155 REM---- EF ---- Effective Tower Flashes
17160 REM---- EM ---- Average Shieldwire Height
17165 REM---- ET(I) - Effective Tower Flashes For Each Conductor
17170 REM---- F  ---- Variable Used In Computing Uncovered Width
17175 REM---- F$ ---- Data Filename
17180 REM---- F2(I) - Flashover Voltage At 2 Microseconds
17185 REM---- F6(I) - Flashover Voltage At 6 Microseconds
17190 REM---- FA$ --- Disk Drive Selector
17195 REM---- FB$ --- Disk Drive Selector
17200 REM---- FC$ --- Disk Drive Selector
17205 REM---- FD$ --- Disk Drive Selector
17210 REM---- FF$ --- Data File Name
17215 REM---- FR ---- Structure Footing Resistance
17220 REM---- FV ---- Flashover Voltage
17225 REM---- GC ---- Surge Impedance Of Shieldwire
17230 REM---- GD ---- Shieldwire Diameter, mm
17235 REM---- GF ---- Ground Flash Density
17240 REM---- GM ---- Variable Used In Computing Combined Surge Impedance
17245 REM---- GS ---- Shieldwire Midspan Sag
17250 REM---- GX(I) - Shieldwire Horizontal Distance
17255 REM---- GY(I) - Shieldwire Vertical Distance
17260 REM---- GZ ---- Surge Impedance Of Shieldwire
17265 REM---- I  ---- Counter
17270 REM---- I2(I) - Critical Stroke Current At 2 Microseconds
17275 REM---- I6(I) - Critical Stroke Current At 6 Microseconds
17280 REM---- IA(J) - Variable Used In Computing Average Phase Current
17285 REM---- IC(I) - Average Value Of Phase Current
17290 REM---- IL ---- Initial Guess Of Minimum Current
17295 REM---- IN ---- Minimum Current
17300 REM---- IOH,IOV,IOVAL --- Horiz and Vert Positions for Input
17305 REM---- IR(J) - Minimum Phase Currents
17310 REM---- IS(I) - Lowest Critical Current
17315 REM---- IT ---- Tower Type
17320 REM---- IU(I) - Integer Value Of IS(I)
17325 REM---- IX ---- Maximum Current
17330 REM---- J  ---- Counter
17335 REM---- K  ---- Counter
17340 REM---- KE(I) - Matrix Of Phase Angles At End Of Domination
17345 REM---- KS(I) - Matrix Of Phase Angles At Start Of Domination
17350 REM---- LA ---- Counter Used To Compute Critical Current
17355 REM---- LB$ --- Page Label
17360 REM---- LBLEN - Page Label Length
17365 REM---- LC ---- Screen Line Counter
17370 REM---- LV(I) - Conductor Voltage
17375 REM---- MM$ --- Units Selection
17380 REM---- MX(I) - Index Of Exposed Conductor
17385 REM---- MY(I) - Index Of Shieldwire Protecting Exposed Conductor
17390 REM---- N  ---- Counter
17395 REM---- N$ ---- Data Source Selection
17400 REM---- NB ---- Number Of Subconductors
17405 REM---- NC ---- Number Of Conductors
17410 REM---- NE ---- Number Of Shieldwires
17415 REM---- NO ---- Counter
17420 REM---- NX ---- Number Of Exposed Conductors
17425 REM---- P1 ---- Probability Of Maximum Current
17430 REM---- PA(I) - Conductor Phase Angle
17435 REM---- PB ---- Probability Of Minimum Current
17440 REM---- PH ---- Phase Angle Used In Computing Critical Current
17445 REM---- PI ---- 3.14159
17450 REM---- PR(I) - Percent Of Time Each Phase Dominates
17455 REM---- PS ---- Tower Damping Factor
17460 REM---- PV ---- Square Root Of 2/3
17465 REM---- PX(I) - Probability Of Flashover By Each Conductor
17470 REM---- RC ---- Shieldwire Corona Radius
17475 REM---- RF(I) - Distribution of Footing Resistance Values
17480 REM---- RH ---- Mean Height Of Conductor
17485 REM---- RN ---- Strokes To Line/ 100 km
17490 REM---- SA(I) - Summing Array For Angles
17495 REM---- SB ---- Integer Of SN
17500 REM---- SD ---- Strike Distance
17505 REM---- SI(I) - Strike Distance
17510 REM---- SM ---- Maximum Strike Distance
17515 REM---- SN ---- Shielding Failure Rate
17520 REM---- SP ---- Span Length
17525 REM---- SS ---- Bachflashover Rate
17530 REM---- SU(I) - Summing Array For Average Current
17535 REM---- SV(I) - Sine Values For Every 10 Degrees
17540 REM---- SZ ---- Surge Impedance Of Conductor
17545 REM---- T1 ---- Angle Variable Used In Computing Average Phase Currents
17550 REM---- T1 ---- Variable Used In Computing H-Frame Travel Time
17555 REM---- T2 ---- Angle Variable Used In Computing Average Phase Currents
17560 REM---- T2 ---- Variable Used In Computing H-Frame Travel Time
17565 REM---- TA(I) - Travel Time For Each Crossarm
17570 REM---- TD ---- Thunderday Level
17575 REM---- TH ---- Thunderhour Level
17580 REM---- TH(J) - Theta
17585 REM---- TM ---- Distance Used In Computing Effective Shield Angle
17590 REM---- TPH --- Distance from Middle to Top (Type 4 Tower Only)
17595 REM---- TOPR -- Tower Top Raduis (Type 4 Tower Only)
17600 REM---- TR ---- Tower Base Radius
17605 REM---- TS ---- Span Travel Time
17610 REM---- TT$ --- Transmission Line Name
17615 REM---- TU ---- Tower Travel Time
17620 REM---- TV ---- Tower Top Voltage
17625 REM---- TW ---- Tower Height
17630 REM---- V2 ---- Tower Top Voltage At 2 Microseconds
17635 REM---- V6 ---- Tower Top Voltage At 6 Microseconds
17640 REM---- VC(I) - Voltage Across Crossarm
17645 REM---- VI(I) - Insulator Voltage
17650 REM---- VJ(I) - Integer of VI(I)
17655 REM---- VL ---- Velocity Of Light
17660 REM---- VP(I) - Integer Of VS(I)
17665 REM---- VR(I) - Voltage Corresponding To Lowest Critical Current
17670 REM---- VS(I) - Insulator Voltage At 6 Microseconds
17675 REM---- VT ---- Tower Top Voltage
17680 REM---- VV ---- Reflected Voltage At 6 Microseconds
17685 REM---- VW ---- Voltage Across Footing Resistance
17690 REM---- WW ---- Tower Midsection Width
17695 REM---- X  ---- Item Number For Data Editor
17700 REM---- X1 ---- Coordinate Of Shieldwire
17705 REM---- X2 ---- Coordinate Of Shieldwire
17710 REM---- XI ---- IC(I)
17715 REM---- XG ---- Coordinate Of Shieldwire
17720 REM---- XS ---- Uncovered Width
17725 REM---- Y$ ---- Error Selection
17730 REM---- YO ---- Variable Used In Computing Maximum Strike Distance
17735 REM---- Z1 ---- Tower Surge Impedance
17740 REM---- Z2 ---- Tower Surge Impedance
17745 REM---- ZI ---- Intrinsic Circuit Impedance
17750 REM---- ZT ---- Tower Surge Impedance
17755 REM---- ZW ---- Tower Wave Impedance
17760 REM---- CUR.COL - Cursor's Current Location
17765 REM---- DD ---- Device Indicator
17770 REM---- DEV$ -- Display Device's name
17775 REM---- FSA --- Output Storage Indicator
18000 REM----------------------------------
18010 REM PROBABILITY OF STROKE CURRENT
18020 REM Input: IINPUT in kA
18030 REM Output: PIGRIN, P(I>IINPUT), 0-1 
18040 REM----------------------------------
18050 PIGRIN = 1/( 1 + (IINPUT/31)^2.6 )
18060 RETURN
20000 REM----------------------------------------------------------------
20010 REM Input: IOH,IOV, cursor positions
20020 REM        IOTTL$, Field Label
20030 REM        IOVAL, initial value
20040 REM Output: IOVAL, unchanged if <return> is pressed.
20050 REM         IOSTR$, String Representation (left=$$$ for string I/O)
20060 REM----------------------------------------------------------------
20070 LENTTL=LEN(IOTTL$)
20080 LOCATE IOH,IOV:PRINT IOTTL$: IOTTL$=""
20090 IF LEFT$(IOSTR$,3)><"$$$" THEN 20130
20100 IOSTR$=MID$(IOSTR$,4)
20110 LOCATE IOH,IOV+LENTTL+2:PRINT IOSTR$
20120 GOTO 20160
20130 IOVVAL=IOV+LENTTL
20140 IF IOVAL<0 THEN LOCATE IOH,IOVVAL+2 ELSE LOCATE IOH,IOVVAL+1
20150 PRINT IOVAL
20160 LOCATE IOH,IOV+LENTTL:INPUT IOTEM$
20170 IF IOTEM$="" THEN 20200
20180 IOVAL=VAL(IOTEM$)
20190 IOSTR$=IOTEM$
20200 RETURN
21000 REM-----------------------------------------
21010 REM Initialize Input Variables to Base Case
21020 REM-----------------------------------------
21030 TT$="FLASH 1.5 Base Case"
21040 NC=3:NE=2
21050 FOR I=1 TO NC:
21060 CX(I)=-10+5*I:CY(I)=35:SI(I)=3:LV(I)=500:PA(I)=-120+120*I:ACDC$(I)="AC"
21070 NEXT I
21080 FOR I=1 TO NE:GX(I)=-9+6*I:GY(I)=40: NEXT I
21090 NX=2
21100 MX(1)=1:MY(1)=1:MX(2)=3:MY(2)=2
21110 NB=4:BS=457:CD=30:CS=0
21120 GD=14:GS=0:IT=4:TW=40:TR=8:TPH=20:WW=4:TOPR=2:SP=300:TD=40
21130 MM=2:FOR I=1 TO 10:RF(I)=110-I*10:NEXT I
21140 RETURN
24000 REM-------------------------------
24010 REM  Plot of Conductor Locations
24020 REM-------------------------------
24030 LB$=" C O N D U C T O R  L O C A T I O N S ":GOSUB 16000
24040 REM--------------------------------------
24050 REM scale: 1 space = 1 meter horizontal
24060 REM        1 space = 3 meter vertical
24070 REM--------------------------------------
24080 FOR ICRUDE = -30 TO 30 STEP 10
24090 LOCATE 23,ICRUDE+40:PRINT"|"
24100 LOCATE 22,(ICRUDE+38):PRINT ICRUDE
24110 NEXT ICRUDE
24120 FOR JCRUDE =   0 TO 60 STEP 10
24130 LOCATE 23-JCRUDE/3,40:PRINT"-";JCRUDE;" m"
24140 NEXT JCRUDE
24150 FOR ICRUDE = 1 TO NE
24160 IF MM=1 THEN LOCATE 23-GY(ICRUDE)/9.84,GX(ICRUDE)/3.28+39:PRINT "S"+RIGHT$(STR$(ICRUDE),1)
24170 IF MM=2 THEN LOCATE 23-GY(ICRUDE)/3,GX(ICRUDE)+39:PRINT "S"+RIGHT$(STR$(ICRUDE),1)
24180 NEXT ICRUDE
24190 FOR ICRUDE = 1 TO NC
24200 IF MM=1 THEN LOCATE 23-CY(ICRUDE)/9.84,CX(ICRUDE)/3.28+39:PRINT ICRUDE
24210 IF MM=2 THEN LOCATE 23-CY(ICRUDE)/3,CX(ICRUDE)+39:PRINT ICRUDE
24220 NEXT ICRUDE
24230 LOCATE 2,5:PRINT"Note the OUTER-MOST INDEX Values Near OHGW locations S1 and S2."
24240 LOCATE 3,5:PRINT "Hit Any Key to Continue.":A$=INPUT$(1)
24250 RETURN
25000 REM-----------------------------
25010 REM  Save all output to a file
25020 REM-----------------------------
25030 FSA=1
25040 FOUT$=DN$+":"+F$
25050 REM LOCATE 10,1:PRINT"OUTPUT WIIL BE SAVED TO FILE :";FOUT$
25060 OPEN FOUT$ FOR OUTPUT AS #1
25070 RETURN
25500 REM ----- save title to disk
25510 PRINT#1, STRING$(INT(LBLEN/2+.6),"-");LB$;STRING$(INT(LBLEN/2),"-")
25520 RETURN
26000 REM-------------------------------
26010 REM  Reset Metric to English unit
26020 REM-------------------------------
26030 FOR I=1 TO NC
26040  CX(I)=CX(I)*3.28:CY(I)=CY(I)*3.28:SI(I)=SI(I)*3.28
26050 NEXT I
26060 FOR I=1 TO NE
26070  GX(I)=GX(I)*3.28:GY(I)=GY(I)*3.28
26080 NEXT I
26090 BS=BS*39.37:CD=CD/25.4:GD=GD/25.4
26100 TW=TW*3.28:TR=TR*3.28:WW=WW*3.28:TPH=TPH*3.28
26110 SP=SP*3.28:CS=CS*3.28:GS=GS*3.28
26120 RETURN
60000 REM------------------------------------
60010 REM  Error handling routine
60020 REM------------------------------------
60030 IF ERL>12060 AND ERL<12100 THEN GOTO 60090
60040 IF ERL>14100 AND ERL <14360 THEN 60160
60050 BEEP:BEEP:CLS
60060 LOCATE 3,1:PRINT"ERROR - PROGRAM TERMINATES - PLEASE CHECK"
60070 PRINT:PRINT"ERROR IN LINE";ERL,"ERROR CODE";ERR
60080 GOTO 63000
60090 BEEP:PRINT:PRINT"FILE NOT FOUND OR MISTYPED";SPC(53):CUR2.COL=CSRLIN
60100 PRINT:PRINT:PRINT"Press any key to continue";SPC(53):A$=INPUT$(1)
60110 IF CUR.COL >22 THEN 60140
60120 LOCATE CSRLIN,1:PRINT STRING$(80," ")
60130 LOCATE CUR2.COL,1:PRINT STRING$(80," "):GOTO 60150
60140 CLS:CUR.COL=1:GOSUB 16000
60150 FF$="!":LOCATE CUR.COL,1:RESUME 12070
60160 REM------------------------------------
60170 REM  printer not ready for data display
60180 REM------------------------------------
60190 BEEP:LOCATE 15,1
60200 PRINT"PRINTER ERROR !!!":PRINT:PRINT"Press any key to continue":A$=INPUT$(1)
60210 CLOSE#1:RESUME 14040
63000 STOP
